//
//***********************************************************************************//
//*	Project:																		*//
//*																					*//
//*	File:		main.c			 													*//
//*	Version:	1.0																	*//
//*																					*//
//*	Author:		Bob Marlowe															*//
//*	(C) 2015	Jörg Meier Software - Entwicklung briefe@jmeiersoftware.de			*//
//***********************************************************************************//
//***********************************************************************************//
//*																					*//
//*		Principles of Operation														*//
//*																					*//
//*																					*//
//*																					*//
//*																					*//
//*																					*//
//*																					*//
//***********************************************************************************//

//***********************************************************************************//
//**************** Libraries ********************************************************//
//***********************************************************************************//
#include <project.h>
#include <stdio.h>
#include <math.h>

//***********************************************************************************//
//**************** Definitions and Macros *******************************************//
//***********************************************************************************//
#define	FALSE					(0)											//	Define logical false and true values
#define	TRUE					(!FALSE)									//	
#define	forever					TRUE										//	I like that for infinite loops

//	Bit handling Macros
#define BitMask(BitNum)			(0x01ul << BitNum)							//	Generating a mask pattern with a set bit at required position
#define TestBit(Value,BitNum)	(Value & BitMask(BitNum))					//	Return bit at given position
#define IsBitSet(Value,Bit)		(?TestBit(Value,BitNum)TRUE:FALSE)			//	Return true or false when bit at position is set
#define SetBit(Value,BitNum)	(Value |=  BitMask(BitNum))					//	Set bit in variable at given position
#define ClrBit(Value,BitNum)	(Value &= ~BitMask(BitNum))					//	Clear bit in variable at given position

#define	Wait(x)																//	To increase readability
#define	ActiveHigh				TRUE
#define LEDOFF					!LEDON	
#define LEDON					!ActiveHigh									//	LEDs are active low in this application

//***********************************************************************************//
//******************* Structs, Typedefs and Enums ***********************************//
//***********************************************************************************//
//	None yet

//***********************************************************************************//
//******************* Data Area *****************************************************//
//***********************************************************************************//
float	MyPI;											
uint8	ShortValue;
uint32	LongValue;
//***********************************************************************************//
//****************** Prototypes *****************************************************//
//***********************************************************************************//
//	None yet

//***********************************************************************************//
//**************** Program Area *****************************************************//
//***********************************************************************************//

void InitializeSystem(void)								//	Start all components, initialize  variables, perform self-test
{
	CyGlobalIntEnable;									//	Enable interrupt handling
	PuTTY_Start();
}

int main()
{
char Buffer[20];										//	Buffer for string to write	
	InitializeSystem();
	
	MyPI 		= 4 * atan(1.0);
	ShortValue	= MyPI;
	LongValue	= (MyPI - ShortValue) * 100000;
	
	PuTTY_UartPutString(" PuTTY Demonstration\n\r");
	
	while(forever)
	{
		sprintf(Buffer,"Float: %f   ",MyPI);
		PuTTY_UartPutString(Buffer);
		
		sprintf(Buffer,"Uint8: %d   ",ShortValue);
		PuTTY_UartPutString(Buffer);
		
		sprintf(Buffer,"Uint32: %ld\n\r",LongValue);
		PuTTY_UartPutString(Buffer);
		
		MyPI++;
		ShortValue++;
		LongValue++;
		
		CyDelay(500);		
    }
}

/* [] End of main.c */


